Subject: Re: NIU driver: Sun x8 Express Quad Gigabit Ethernet Adapter

From: Ben Hutchings <[email-masked]>
Date: Wed, 12 Nov 2008 21:50:57 +0000

On Wed, 2008-11-12 at 13:46 -0800, David Miller wrote:
> From: Ben Hutchings <[email-masked]>
> Date: Wed, 12 Nov 2008 12:54:53 +0000
> 
> > On Wed, 2008-11-12 at 04:11 -0800, David Miller wrote:
> > [...]
> > > So the following patch should fix this bug.  writeq() should
> > > be OK as-is, so doesn't need a similar change.
> > > 
> > > diff --git a/drivers/net/niu.c b/drivers/net/niu.c
> > > index 9acb5d7..d8463b1 100644
> > > --- a/drivers/net/niu.c
> > > +++ b/drivers/net/niu.c
> > > @@ -51,8 +51,7 @@ MODULE_VERSION(DRV_MODULE_VERSION);
> > >  #ifndef readq
> > >  static u64 readq(void __iomem *reg)
> > >  {
> > > -	return (((u64)readl(reg + 0x4UL) << 32) |
> > > -		(u64)readl(reg));
> > > +	return ((u64) readl(reg)) | (((u64) readl(reg + 4UL)) << 32);
> > >  }
> > 
> > Since there's no sequence point between the reads, there's no guarantee
> > that the reads happen in the order written (regardless of barriers
> > inside readl()).  This needs to be split into two statements.
> 
> What version of the C language are you using?

Any version will do.

> I personally think it's safe.  If the compiler sees "A | B" it's going
> to emit the code to compute A, then the code to emit B, and finally
> the "|" operation.
> 
> Everything I've always seen says that for "|" the expressions are
> evaluated left to right.

I think you're confusing it with "||" which does have this sequencing
rule.

See <http://c-faq.com/expr/seqpoints.html> if you're not convinced.

Ben.

-- 
Ben Hutchings, Senior Software Engineer, Solarflare Communications
Not speaking for my employer; that's the marketing department's job.
They asked us to note that Solarflare product names are trademarked.